use anyhow::{
    Context,
    Result,
};
use feed_rs::{
    parser::parse,
    model::Feed,
};

fn fetch_feed() -> Result<Feed> {
    let content = reqwest::blocking::get("https://www.youtube.com/feeds/videos.xml?channel_id=UC0intLFzLaudFG-xAvUEO-A")?.bytes()?;
    Ok(parse(&content[..])?)
}

fn main() -> Result<()> {
    let feed = fetch_feed()?;

    let mut out = String::new();

    out.push_str("<!DOCTYPE html>\n");
    out.push_str("<html>\n");
    out.push_str("<head>\n");
    out.push_str("</head>\n");
    out.push_str("<body>\n");

    out.push_str("<ul>\n");

    for item in feed.entries {
        out.push_str(&format!("<li><a href=\"{}\">{}</a></li>\n", item.links.first().context("No link found")?.href, item.title.context("No title found")?.content));
    }

    out.push_str("</ul>\n");

    out.push_str("</body>\n");
    out.push_str("</html>\n");

    std::fs::write("index.html", out)?;

    Ok(())
}
